<?

 /******************************************************************************************
 * Filename: modules/achievements.php
 *
 * This file is part of the Achievements JAS plugin.
 * Copyright 2003-2017 by Matthijs Schuurman
 *
 * The Achievements JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/achievements/
 ******************************************************************************************/


 require_once($_path["include"]."module.php");
 require_once($_path["include"]."mutilate.php");
 require_once($_path["include"]."fs.php");

 require_once($_path["project"]["plugins"]."achievements/script.php");

 class Plugin_Module_achievements_achievements extends Module
 {
  function __construct(&$data)
  {
   parent::__construct($data);

   $this->data->title="Achievements";
   $this->data->defaultFields();

   $this->data->addField("name", "title", "all", "", 1, 255, false, "Name");
   $this->data->addField("title", "text", "all", "title", 1, 255, false, "Title");
   $this->data->addField("description", "text", "all", "markup", 0, 65536, false, "Description");

   $this->data->addField("script", "text", "all", "", 0, 65536, false, "Script");
   $this->data->addField("disabled", "boolean", "all", "", false, false, false, "Disabled");

   $this->data->addField("badge", "image", "all", "", 0, 1024*1024, false, "Badge");
   $this->data->addField("badge2", "image", "all", "", 0, 1024*1024, false, "Completed badge");

   $this->data->addField("progress", "float", "", "", 0, 1, false, "Progress");

   $this->data->group("Logic", "script", "disabled");
   $this->data->group("Badge", "badge", "badge2");

   $this->data->sortOrder("title");
  }

  function viewPreGet()
  {
   global $_config, $_path, $_badgeProgress;

   if($this->data->dataformat=="html") //get disabled field for title
    if($this->data->check("use", "show", "title"))
     if(!$this->data->check("use", "show", "disabled"))
      $this->data->field["disabled"]["use"].=";show";

   if(!$_badgeProgress)
   {
    if(getcwd()."/"==FS::realPathS(getcwd()."/".$_path["images"])&&$_path["file"]=="index.php"&&request("p", 3)=="progress") //$root/images/achievements_achievements/badge/1/progress/ called
    {
     $this->data->field["progress"]["use"].=";show";
     $_badgeProgress=true;
    }
   }

   if($this->data->check("use", "show", "progress")&&!$_config->userAnonymous()) //get badge2 field for badge progress
   {
    foreach(array_keys($this->data->field) as $field2)
    {
     if(strpos($field2, "badge2")===0)
     {
      $field=str_replace(2, "", $field2);
      if($this->data->check("use", "show", $field)&&!$this->data->check("use", "show", $field2))
       $this->data->field[$field2]["use"].=";show";
     }
    }
   }

   return true;
  }

  function viewPostGet()
  {
   global $_config;

   if($this->data->dataformat=="html") //add disabled marker to title
    for($c=0;$c<$this->data->vmax;$c++)
     if($this->data->getValue("disabled", $c))
      $this->data->setValue("title", $this->data->getValue("title", $c)." &#735;", $c);

   //apply user's progress to information
   if($this->data->check("use", "show", "progress")&&!$_config->userAnonymous())
   {
    for($c=0;$c<$this->data->vmax;$c++) //get progress
     $this->data->field["progress"]["value"][$c]=$this->progress($this->data->getValue("nr", $c));

    for($c=0;$c<$this->data->vmax;$c++)
    {
     if($this->data->getValue("progress", $c)===true||$this->data->getValue("progress", $c)>=1)
     {
      foreach(array_keys($this->data->field) as $field2)
      {
       if(strpos($field2, "badge2")===0&&isset($this->data->field[$field2]["value"][$c]))
       {
        $field=str_replace(2, "", $field2);
        $this->data->field[$field]["value"][$c]=$this->data->field[$field2]["value"][$c];
        unset($this->data->field[$field2]["value"][$c]);
       }
      }
     }
    }

    foreach(array_keys($this->data->field) as $field2) //don't show badge2 fields
     if(strpos($field2, "badge2")===0)
      $this->data->field[$field2]["use"]=str_replace(";show", "", $this->data->field[$field2]["use"]);
   }

   if($this->data->check("use", "show", "description")) //capture relevant part of description
    for($c=0;$c<$this->data->vmax;$c++)
     $this->data->field["description"]["value"][$c]=$this->description($this->data->getValue("description", $c), $this->data->getValue("progress", $c));

   return true;
  }


  function addPreSubmitErrorCheck(){return $this->autofill();}
  function copyPreSubmitErrorCheck(){return $this->autofill();}
  function editPreSubmitErrorCheck(){return $this->autofill();}

  function autofill()
  {
   for($c=0;$c<$this->data->vmax;$c++)
   {
    if(!($name=$this->data->getValue("name", $c)))
    {
     if($name=$this->data->getValue("title", $c))
     {
      $name=strtolower($name);
      $this->data->setValue("name", $name, $c);
     }
    }

    if($name)
    {
     if(!ctype_lower($name))
     {
      $name=strtolower($name);
      $this->data->setValue("name", $name, $c);
     }

     if(!$this->data->getValue("title", $c))
      $this->data->setValue("title", ucfirst($name), $c);
    }
   }

   return true;
  }


  /*
   * Miscellaneous
   */

  static function description($text, $progress)
  {
   $description="";
   $descriptions=Array();
   if($l=preg_match_all("/(^|\[(\d+)\])([^\[]+)/m", $text, $m))
   {
    for($c=0;$c<$l;$c++)
    {
     $descriptions[$m[2][$c]]=trim($m[3][$c]);
     if(strpos($descriptions[$m[2][$c]], "<")!==false&&($lb=Mutilate::detectLineBreaksS($descriptions[$m[2][$c]]))) //contains HTML
     {
      $descriptions[$m[2][$c]]=preg_replace("!<br[^>]*>!i", "", $descriptions[$m[2][$c]]); //remove <br/>
      $descriptions[$m[2][$c]]=trim($descriptions[$m[2][$c]]); //trim again
      $descriptions[$m[2][$c]]=str_replace($lb, "<br/>".$lb, $descriptions[$m[2][$c]]); //add <br/>
     }
    }
   }

   if(!$progress) //no progress
   {
    if(isset($descriptions[0]))
     $description=$descriptions[0];
    else if(isset($descriptions[""]))
     $description=$descriptions[""];
   }
   else if($progress===true||$progress>=1) //achieved
   {
    if(isset($descriptions[100]))
     $description=$descriptions[100];
    else if(isset($descriptions[""]))
     $description=$descriptions[""];
   }
   else //in progress
   {
    $progress*=100;

    foreach($descriptions as $k => $v)
     if($k===""||$progress>=$k)
      $description=$v;
   }

   return $description;
  }


  static function progress($achievement)
  {
   global $_config;

   $usernr=$_config->get("usernr");

   if($usernr==$_config->get("anonnr"))
    return false;

   //get score
   $dp=Data::cache("achievements_progress", "view", "all");

   if(preg_match("/^\d+$/", $achievement)) //achievement id
    $dp->setFilter("usernr='".$usernr."' AND achievementnr='".$achievement."'");
   else //achievement name
    $dp->setFilter("usernr='".$usernr."' AND achievementnr.name='".$achievement."'");

   $dp->setShowFields("progress");
   $dp->sortOrder();

   if($dp->get())
    if($dp->getValue("progress")>=1) //achieved
     return true; //done


   //get script
   $d=Data::cache("achievements_achievements", "view", "all", Array("format" => "text"));

   $d->clearValues();

   if(preg_match("/^\d+$/", $achievement)) //achievement id
    $d->setValue("nr", $achievement);
   else //achievement name
    $d->setValue("name", $achievement);

   $d->setValue("disabled", false);

   $d->setShowFields("script");

   if(!$d->get())
    return false;
   else if(!$d->next()) //achievement not found/disabled
   {
    if($dp->vmax) //already has progress
     return $dp->getValue("progress");

    return 0; //no progress
   }

   //run script
   $script=new Achievements_Script();
   $script->set("usernr", $usernr);

   if(!$script->parse("achievement", $d->v["script"]))
    return false;

   if(($progress=$script->execute("achievement"))===false)
    return false;

   if($progress<0)
    $progress=0;
   else if($progress>1)
    $progress=1;

   //update progress if necessary
   if($dp->next()) //entries exists
   {
    if(!$progress) //no progress
    {
     $dp->setAction("delete");
     $dp->setExtra("all");

     $dp->clearValues();
     $dp->setValue("usernr", $usernr);
     $dp->setValue("achievementnr", $d->v["nr"]);

     $dp->submit();
    }
    else if($progress!=$dp->v["progress"]) //progress changed
    {
     $dp->setAction("edit");
     $dp->setExtra("all");

     $dp->clearValues();
     $dp->setValue("usernr", $usernr);
     $dp->setValue("achievementnr", $d->v["nr"]);
     $dp->setValue("progress", $progress);

     $dp->submit();
    }
   }
   else //no entry yet
   {
    if($progress) //progress
    {
     $dp->setAction("add");
     $dp->setExtra("item");

     $dp->clearValues();
     $dp->setValue("usernr", $usernr);
     $dp->setValue("achievementnr", $d->v["nr"]);
     $dp->setValue("progress", $progress);

     $dp->submit();
    }
   }

   return $progress;
  }
 }
?>
