<?

 /******************************************************************************************
 * Filename: modules/progress.php
 *
 * This file is part of the Achievements JAS plugin.
 * Copyright 2003-2017 by Matthijs Schuurman
 *
 * The Achievements JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/achievements/
 ******************************************************************************************/


 require_once($_path["include"]."module.php");

 class Plugin_Module_achievements_progress extends Module
 {
  function __construct(&$data)
  {
   global $_config;

   parent::__construct($data);

   $this->data->title="Achievements progress";

   $this->data->defaultFields("added;updated");

   $this->data->addField("userrights", "rights", "", "allusers", 0, false, 512); //add rights for all

   $this->data->addField("usernr", "nr", "all", "title;owner", 1, false, $_config->get("usernr"), "User");
   $this->data->addReference("usernr", $_config->get("usermodule"), "nr", "*:1", "usernr");

   $this->data->addField("progress", "float", "all", "title", false, false, false, "Progress");

   $this->data->addField("achievementnr", "nr", "all", "title", 1, false, 0, "Achievement");
   $this->data->addReference("achievementnr", "achievements_achievements", "nr", "*:1", "achievementnr");

   $this->data->addUnique("identifier", "usernr", "achievementnr");

   $this->data->sortOrder("usernr", "progress-");
  }
 }
?>
