<?

 /******************************************************************************************
 * Filename: setup.php
 *
 * This file is part of the Achievements JAS plugin.
 * Copyright 2003-2017 by Matthijs Schuurman
 *
 * The Achievements JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/achievements/
 ******************************************************************************************/


 class Plugin_Setup_achievements extends Base_Plugin_Setup
 {
  function init()
  {
   global $_path;

   $this->mkdir($_path["project"]["images"]);
   $this->mkdir($_path["project"]["images"]."badges/");
   $this->mkdir($_path["project"]["script"]);
   $this->mkdir($_path["project"]["style"]);

   $this->file("setup/achievements.js", $_path["project"]["script"]);
   $this->file("setup/backend.css", $_path["project"]["style"]);

   //create modules
   $this->modules(
    "achievements_achievements",
    "achievements_progress"
   );


   //create container
   if(!$this->data("categories", Array("catnr", "text"), Array(
    Array(
     "catnr" => 1,
     "name" => "Achievements",
     "text" => "ACHIEVEMENTS",
     "module" => Array("achievements_achievements"),
    ),
   )))
    return false;

   $d=Data::cache("categories", "view", "all");
   $d->setValue("catnr", 1);
   $d->setValue("text", "ACHIEVEMENTS");
   $d->setShowFields();

   if($d->get()&&$d->next())
    $catnr=$d->v["nr"];
   else
    $catnr=1;


   //create search words
   if(!$this->data("achievements_achievements", Array("name"), Array(

    Array("catnr" => $catnr, "disabled" => true, "name" => "owner", "title" => "Owner", "script" => "count categories 'owner=|usernr|' == |owned|
 divide |owned| 10 == |progress|
  exit |progress|
"),

   )))
    return false;

   return true;
  }

 }
?>
