

 /******************************************************************************************
 * Filename: setup/achievements.js
 *
 * This file is part of the Achievements JAS plugin.
 * Copyright 2003-2017 by Matthijs Schuurman
 *
 * The Achievements JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/achievements/
 ******************************************************************************************/


if(typeof(HTTP)!='function')
 alert("Script not loaded: http.js");

function achievementsCheck(name)
{
 var http=new HTTP();
 http.setValue("disabled", 0);

 if(typeof(name)=="string")
  http.setValue("name", name);

 http.show("nr", "name", "title", "description", "badge", "progress")

 if(!http.data("achievements_achievements", "view", "all", achievementsChecked))
  return false;

 return true;
}

function achievementsChecked(http)
{
 var v=false;
 var achieved="";

 var root=rootpath;
 if(window.location.toString().match("/jas/project/")) //runs in JAS backend
  root+="project/";

 while(v=http.next())
 {
  if(v["progress"]===1.0)
  {
   achieved+="<a href=\""+root+"achievements/#"+v["name"].replace(" ", "_")+"\" class=\"achievement p100\">";
   achieved+=" <div class=\"badge\"><img src=\""+rootpath+"images/achievements_achievements/badge/"+v["nr"]+"/progress/\" /></div>";
   achieved+=" <div class=\"title\">"+v["title"]+"</div>";
   achieved+=" <div class=\"description\">"+v["description"]+"</div>";
   achieved+="</a>";
  }
 }

 if(achieved)
 {
  var div=document.createElement("div");
  div.className="notifications";
  div.innerHTML=achieved;

  document.body.insertBefore(div, document.body.firstChild);
  div.addEvent("click", notificationsClose);
 }
}

function notificationsClose()
{
 var flash=new Flash(document.body.firstChild);
 flash.opacity(100, 0);
 flash.opacity(0, 200);
 flash.end("self.obj.style.display=\"none\";");
 flash.go();

 return true;
}

